﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Text;
using Xamarin.Forms;

namespace Schedule
{
    public class ScheduleViewModel : INotifyPropertyChanged
    {

        private bool _showAllDAy;
        public bool ShowAllDay
        {
            get { return _showAllDAy; }
            set
            {
                if (_showAllDAy != value)
                {
                    _showAllDAy = value;
                    OnPropertyChanged("ShowAllDay");
                }
            }
        }

        public Command ToggleShowAllDayCommand => new Command(ToggleShowAllDay);

        private void ToggleShowAllDay()
        {
            ShowAllDay = !ShowAllDay;
        }

        public ObservableCollection<Meeting> meetings = new ObservableCollection<Meeting>();

        public event PropertyChangedEventHandler PropertyChanged;

        public ScheduleViewModel()
        {
            Meeting client = new Meeting();
            client.Start = new DateTime(2019, 07, 3, 10, 0, 0);
            client.End = client.Start.AddHours(1);
            client.TitleText = "Client Meeting";
            client.IsAllDay = true;
            meetings.Add(client);

            Meeting checkup = new Meeting();
            checkup.Start = new DateTime(2019, 07, 4, 9, 0, 0);
            checkup.End = checkup.Start.AddHours(1);
            checkup.TitleText = "Checkup";
            checkup.IsAllDay = true;
            meetings.Add(checkup);

            Meeting conference = new Meeting();
            conference.Start = new DateTime(2019, 07, 5, 12, 0, 0);
            conference.End = conference.Start.AddHours(2);
            conference.TitleText = "Conference";
            conference.IsAllDay = false;
            meetings.Add(conference);

            ShowAllDay = false;
        }

        public ObservableCollection<Meeting> Meetings
        {
            get { return this.meetings; }
            set { this.meetings = value; }
        }

        protected virtual void OnPropertyChanged(string propertyName)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

    }
}
